var DATABASE_NAME        = "galo_na_veia";
var DATABASE_VERSION     = "1.0";
var DATABASE_DESCRIPTION = "banco de dados local";
var DATABASE_SIZE        = 2*1024*1024;

var db;

function initDatabase(configs,tables,callback){  	
  db = openDatabase(configs.dbName,configs.dbVersion,configs.dbDescription,configs.dbSize);
  if(!db){
  	 mError("Falha ao criar banco de dados local");
  }


  db.transaction(function(transaction){  	  
  	    var i;
  	    var stmt;

  	    for(i in tables){
  	    	tbl = tables[i];  	    	
  	    	transaction.executeSql("CREATE TABLE IF NOT EXISTS "+tbl+" (id UNIQUE,value)");	
  	    }	
  	    callback();	
  });  
}

function getDbData(table,id, successCallback, failureCallback){
	db.transaction(function(transaction){
		var success = function(tx,result){			
			var obj;
			if((result)&&(result.rows.length>0)){
				var strObj = result.rows.item(0).value;
				obj = JSON.parse(strObj);
			}
			successCallback(obj);
		}
		transaction.executeSql("SELECT * FROM "+table+" WHERE id = ? ",[id],success,failureCallback);
	});
}

function getDbDataList(table,successCallback, failureCallback){
	db.transaction(function(transaction){
		var success = function(tx,result){
			var i;
			var resultObj = [];
			if(result){
				for(i = 0;i<result.rows.length;i++){
					var strObj = result.rows.item(i).value;
					var obj = JSON.parse(strObj);	
					resultObj.unshift(obj);		
				}			
			}
			successCallback(resultObj);
		}
		transaction.executeSql("SELECT * FROM "+table+" WHERE 1 = 1 ",[],success,failureCallback);
	});
}

function setDbData(table,object,success,failure){
    db.transaction(function(transaction){    	
    	var dbSuccess = function(){
    		transaction.executeSql("INSERT INTO "+table+" (id,value) VALUES (?,?)",[object.id,JSON.stringify(object)],success,failure);
    	}
    	transaction.executeSql("DELETE FROM "+table+" WHERE id = ?",[object.id],dbSuccess,failure);    	
    });
}

function clearDbData(table,success,failure){
	db.transaction(function(transaction){
		transaction.executeSql("DELETE FROM "+table,[],success,failure);
	});
}

function removeDbData(table,object,success,failure){
	db.transaction(function(transaction){
		transaction.executeSql("DELETE FROM "+table+" WHERE id = ?",[(object.id ? object.id : object)],success,failure);
	});
}

function getDataBase(){
	return db;
}