

var controllers    = [];
var screenHistory  = []; 
var createdScreens = [];
var callers        = [];
var activeScreen;  

function registerController(screenName,controller){
	controllers[screenName] = controller;
	if(controller["onRegister"]){
		controller.onRegister();
	}
}

function getCaller(screenName){
	return callers[screenName];
}

function setCaller(screenName,screenCaller){
	callers[screenName] = screenCaller;
}

function getController(screenName){
	return controllers[screenName];
}

function getScreenName(controller){
	for(var i in controllers){
		if(controllers[i]===controller){
			return controllers[i];
		}
	}
	return null;
}
//function closeA

function openScreen(screenName,allowDuplicate){
	if(activeScreen){
		var controllerAtual = controllers[activeScreen];
		if(controllerAtual){
			if(controllerAtual["beforeChange"]){
				controllerAtual.beforeChange();
			}
		}
	}
	var controller = controllers[screenName];
	if(controller){
		if(controller["beforeOpen"]){
			controller.beforeOpen();
		}
	}

	$( ":mobile-pagecontainer" ).pagecontainer("change","#"+screenName);
	callers[screenName] = activeScreen;

	if(controllerAtual){
		if(controllerAtual["onChange"]){
			controllerAtual.onChange();
		}
	}	

	if(controller){
		if(!createdScreens[screenName]){
			if(controller["onCreate"]){				
				controller.onCreate();
			}
			createdScreens[screenName] = true;
		}
	}
			
	
	var pos;	
	do{
		pos = screenHistory.indexOf(screenName);
		if((pos>-1)&&(!allowDuplicate))
		   screenHistory.splice(pos,1);
	}while(pos>-1);	
	screenHistory.push(screenName);

	activeScreen = screenName;

	if(controller){
		if(controller["onOpen"]){
			controller.onOpen();
		}
	}

	return getController(screenName);
}


/**
 * Fecha todas as telas, até voltar à tela passada por parâmetro
 */
function backToScreen(screen){
	if(createdScreens[screen]){

			var i = screenHistory.length-1;
			while(screenHistory[i]!==screen){						
				createdScreens[screenHistory[i]] = false;
				var controller = controllers[screenHistory[i]];
				if((controller)&&(controller.onClose)){
					controller.onClose();
				}
				screenHistory.splice(i,1);			
				//closeScreen();
				i = screenHistory.length-1;			
			}					
			$( ":mobile-pagecontainer" ).pagecontainer("change","#"+screen);
			activeScreen = screen;
			if(controllers[screen]){
				if(controllers[screen].onResume){
					controllers[screen].onResume();
				}
			}						
	}
	return getController(screen);
}

/** 
 * Verifica se a tela já foi criada
 */
function isCreatedScreen(screen){
	return createdScreens[screen];
}

/**
 * Fecha uma tela ativa e retorna o controle para a tela do topo da pilha, disparando o evento "onResume"
 */
function closeScreen(){

	screenName = activeScreen;

	var controller = controllers[screenName];
	if(controller){
		if(controller["beforeClose"]){
			controller.beforeClose();
		}
	}

	var pos;	
	do{
		pos = screenHistory.indexOf(screenName);
		if(pos>-1)
		   screenHistory.splice(pos,1);
	}while(pos>-1);	
	createdScreens[screenName] = false;

	if(controller){
		if(controller["onClose"]){
			controller.onClose();
		}
	}

	activeScreen = screenHistory.pop();
	screenHistory.push(activeScreen);

	$( ":mobile-pagecontainer" ).pagecontainer("change","#"+activeScreen);

	var newController = controllers[activeScreen];
	if(newController){
		if(newController["onResume"]){
			newController.onResume();
		}
	}
}

