

/**
 * Realiza o parse da string de data no formato enviado pelo servidor em um objeto da classe Date
 * @param dateToFormat - a data a ser convertido, no formato "YYYY-MM-DD'T'HH-mm-ss*"
 */
function parseDate(dateToFormat){

	var ano     = dateToFormat.substr(0,4);
	var mes     = dateToFormat.substr(5,2);
	var dia     = dateToFormat.substr(8,2);
	var hora    = dateToFormat.substr(11,2);
	var minuto  = dateToFormat.substr(14,2);
	var segundo = dateToFormat.substr(17,2);  

	var date = new Date();
	date.setYear(ano);
	date.setMonth(mes-1);
	date.setDate(dia);
	date.setHours(hora);
	date.setMinutes(minuto);
	date.setSeconds(segundo);
	date.setMilliseconds(0);
	return date;
}

function formatDate(dateToFormat){
	var ano = dateToFormat.getFullYear();
	var mes = dateToFormat.getMonth()+1;
	var dia = dateToFormat.getDate(); 
	return ajustaZeros(dia,2) + '/' + ajustaZeros(mes,2) + '/' + ano;
}

function formatTime(timeToFormat){
	return timeToFormat.toLocaleTimeString();
}

function formatDateTime(dateTimeToFormat){	
	
	
	return  formatDate(dateTimeToFormat) + ' ' +formatTime(dateTimeToFormat);
}


